;************************************************************************
;*
;*	Filename : Ball.x65
;*	Version  : 1.0
;*	(c) 1993 Nintendo of America Inc.
;*	Translation : Shoya Tanaka
;*
;************************************************************************
;
;
;	define object data
;
		LIB	DEFINE\65816.DEF
		LIB	DEFINE\SFC.DEF
;
		PUBLIC	Set_sprite,Preset_ball
PAGE0		GROUP
		EXTERN	object_code
		EXTERN	object_M,object_X,object_Y,object_Z,object_C
BANK0		GROUP
		EXTERN	Null,Pose,Size,Project
		EXTERN	Appeal_object
CODE		GROUP
		EXTERN	Sort_object,Born_object
;
DATA		GROUP
object0		DS	16
object1		DS	16
object2		DS	16
object3		DS	16
object4		DS	16
object5		DS	16
object6		DS	16
object7		DS	16
object8		DS	16
object9		DS	16
objectA		DS	16
objectB		DS	16
objectC		DS	16
objectD		DS	16
objectE		DS	16
objectF		DS	16
;
BANK0		GROUP
instance0	DW	$200,$100,$100,$0000
instance1	DW	$100,$300,$300,$0200
instance2	DW	$280,$180,$200,$0400
instance3	DW	$300,$200,$080,$0600
instance4	DW	$280,$180,$180,$0800
instance5	DW	$180,$380,$080,$0A00
instance6	DW	$200,$100,$280,$0C00
instance7	DW	$380,$280,$180,$0E00
instance8	DW	$210,$190,$100,$0000
instance9	DW	$190,$290,$100,$0200
instanceA	DW	$210,$210,$180,$0400
instanceB	DW	$290,$290,$180,$0600
instanceC	DW	$150,$170,$080,$0800
instanceD	DW	$1A0,$190,-$F0,$2A00
instanceE	DW	$120,$530,$280,$0C00
instanceF	DW	$4A0,$190,$000,$0E00
instanceZ
;
pos11		DW	-4
pos22H		DW	-8,0,-8,0
pos22V		DW	-8,-8,0,0
pos33H		DW	-12,-4,4,-12,-4,4,-12,-4,4
pos33V		DW	-12,-12,-12,-4,-4,-4,4,4,4
pos44		DW	-16
pos88H		DW	-32,-0,-32,-0
pos88V		DW	-32,-32,-0,-0
small		DW	0,0,0,0,0,0,0,0,0
large		DW	1,1,1,1
ball0		DW	Null
ball1		DW	Pose,0,pos11,pos11,small,$203E
ball2		DW	Pose,0,pos11,pos11,small,$203D
ball3		DW	Pose,0,pos11,pos11,small,$203C
ball4		DW	Pose,0,pos11,pos11,small,$202F
ball5		DW	Pose,0,pos11,pos11,small,$202E
ball6		DW	Pose,0,pos11,pos11,small,$202D
ball7		DW	Pose,0,pos11,pos11,small,$202C
ball8		DW	Pose,0,pos11,pos11,small,$201F
ball9		DW	Pose,0,pos11,pos11,small,$201E
ballA		DW	Pose,0,pos11,pos11,small,$201D
ballB		DW	Pose,0,pos11,pos11,small,$201C
ballC		DW	Pose,6,pos22H,pos22V,small,$200F,$600F,$A00F,$E00F
ballD		DW	Pose,6,pos22H,pos22V,small,$200E,$600E,$A00E,$E00E
ballE		DW	Pose,6,pos22H,pos22V,small,$200D,$600D,$A00D,$E00D
ballF		DW	Pose,6,pos22H,pos22V,small,$200C,$600C,$A00C,$E00C
ballG		DW	Pose,16,pos33H,pos33V,small
		DW	$200D,$2033,$600D,$2033,$2033,$2033,$A00D,$2033,$E00D
ballH		DW	Pose,0,pos44,pos44,large,$2008
ballI		DW	Pose,6,pos88H,pos88V,large,$2004,$6004,$A004,$E004
ballJ		DW	Pose,6,pos88H,pos88V,large,$2000,$6000,$A000,$E000
ballK		DW	Null
ballS		DW	648,495,350,248,177,132,113,96,79,64
		DW	53,44,37,31,26,22,19,16,12,8,0
ball		DW	Project
		DW	Size,ballS
		DW	ballK,ballJ,ballI,ballH,ballG
		DW	ballF,ballE,ballD,ballC,ballB,ballA,ball9,ball8
		DW	ball7,ball6,ball5,ball4,ball3,ball2,ball1,ball0
;
CODE		GROUP
		mwxw
Preset_ball	LDX	#object0			;w
		LDY	#instance0			;w
_loop		LDA	#ball				;w
		STA	.object_code,X			;w
		LDA	!0,Y				;w
		STA	.object_X,X			;w
		LDA	!2,Y				;w
		STA	.object_Y,X			;w
		LDA	!4,Y				;w
		STA	.object_Z,X			;w
		LDA	!6,Y				;w
		STA	.object_C,X			;w
		PHY					;>>
		PHX					;>>
		JSL	~Born_object
		CLC
		PLA					;<<
		ADC	#object1-object0		;w
		TAX
		CLC
		PLA					;<<
		ADC	#instance1-instance0		;w
		TAY
		CMP	#instanceZ			;w
		BNE	_loop
		mB
		LDA	#sprite_bank*2+sprite_0832	;b
		STA	!Sprite_bank			;b
		mW
		RTL
;
		mwxw
Set_sprite	JSL	~Appeal_object
		JSL	~Sort_object
		RTL
;
		END
