;************************************************************************
;*
;*	Filename : DSP1Demo.x65
;*	Version  : 1.0
;*	(c) 1993 Nintendo of America Inc.
;*	Translation : Shoya Tanaka
;*
;************************************************************************
;
;
;	DSP1 demonstration
;
		LIB	DEFINE\65816.DEF
		LIB	DEFINE\SFC.DEF
		LIB	DEFINE\MACRO.DEF
;----------------------------------------------------------------------
		PUBLIC	nmi_control
		PUBLIC	PERSP_bank,PERSP_data,PERSP_status
CODE		GROUP
		EXTERN	Initiate_NMI,Execute_NMI
		EXTERN	Init_process,Fork_process,Post_field,Wait_field
		EXTERN	Param_process,Persp_process
		EXTERN	Control_process,Sprite_process
		EXTERN	Initiate_object,Preset_ball
BANK3		GROUP
		EXTERN	Data_color,Data_logo,Data_ball,Screen_ground
;----------------------------------------------------------------------
PAGE0		GROUP
		ORG	$0000
DATA		GROUP
		ORG	$0200
BANK0		GROUP
		ORG	$8000
CODE		GROUP
		ORG	$8000
BANK3		GROUP
		ORG	$8000
;
PAGE0		GROUP
nmi_control	DS	1
;
		LIB	DEFINE\NMI.DEF
;
		LIB	DEFINE\RESET.DEF
		LIB	DEFINE\MODE7.DEF
		LDA	#scan_button			;b
		STA	.nmi_control			;b
;
		mWxW
		JSL	~Initiate_NMI
		JSL	~Init_process
		JSL	~Initiate_object
;
		mBxB
		JSL	~Data_color		;set up pallete
;
		xW
		JSL	~Data_logo		;set up character
		JSL	~Data_ball
		JSL	~Screen_ground		;set up screen
		mWxW
		JSL	~Preset_ball		;set up sprite
;
		JSL	~Persp_process		;set up display data
		JSL	~Control_process	;make next screen parameter
		JSL	~Param_process		;set up next screen parameter
		JSL	~Sprite_process		;make next screen data
;
idle		JSL	~Wait_field
		BRA	idle
;
PERSP		GROUP
PERSP_bank	EQU	$3F
		ORG	$8000
PERSP_data	DS	$4000
PERSP_status	DS	$4000
;
		END
