;************************************************************************
;*
;*	Filename : PATTERN.X65
;*	Version  : 1.0
;*	(c) 1993 Nintendo of America Inc.
;*	Translation : Shoya Tanaka
;*
;************************************************************************
;
		LIB	DEFINE\65816.DEF
		LIB	DEFINE\SFC.DEF
;
		PUBLIC	Data_color,Data_logo,Data_ball
		PUBLIC	Screen_ground,Screen_logo
CODE		GROUP
		EXTERN	Reserve_NMI
;
PAGE0		GROUP
count		DS	1
;
CODE		GROUP
		mbxw
Data1_7		STX	!Screen_address			;w
		LDA	#step_H+step_1			;b
		STA	!Screen_step			;b
		PLX					;<<
		PLB					;<
		SEC
		BRA	_entry
_loop_B		STA	.count				;b
		INX
		LDA	!1,X				;b
		XBA
_loop_C		LDY	#8				;w
_loop_V		INX
		LDA	!1,X				;b
		ROL	A
_loop_H		BCS	_skip
		STZ	!Screen_write+1			;b
		BRA	_common
_skip		XBA
		STA	!Screen_write+1			;b
		XBA
_common		ASL	A
		BNE	_loop_H
		DEY
		BNE	_loop_V
		DEC	.count				;b
		BNE	_loop_C
		INX
_entry		LDA	!1,X				;b
		BNE	_loop_B
		PHA					;>
		PLB					;<
		RTL
;
		mbxw
Data1_4		STX	!Screen_address			;w
		LDA	#step_H+step_1			;b
		STA	!Screen_step			;b
		PLX					;<<
		PLB					;<
		LDA	!1,X				;b
		STA	.count				;b
_loop2		LDY	#8
_loop0		INX
		LDA	!1,X				;b
		STA	!Screen_write+0			;b
		STZ	!Screen_write+1			;b
		DEY
		BNE	_loop0
		mW
		LDA	#8				;b
_loop1		STZ	!Screen_write+0			;w
		DEC	A
		BNE	_loop1
		mB
		DEC	.count				;b
		BNE	_loop2
		PHA					;>
		PLB					;<
		RTL
;
BANK3		GROUP
Color_screen	DW	$0000,$7FFF,$7C00,$001F,$03E0,$03FF,$7C1F,$7FE0
Color_sprite	DW	0,$021F,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		DW	0,$401F,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		DW	0,$7D00,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		DW	0,$001F,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		DW	0,$03E0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		DW	0,$03FF,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		DW	0,$7C1F,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		DW	0,$7FE0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;
		mbxb				;define palette
Data_color	PHB					;>
		PHK					;>
		PLB					;<
		LDX	#0				;b
		STX	!Color_address
_loop0		LDA	!Color_screen,X			;b
		STA	!Color_write			;b
		INX
		BNE	_loop0
_loop1		LDA	!Color_sprite,X			;b
		STA	!Color_write			;b
		INX
		BNE	_loop1
		PLB					;<
		RTL
;
		mbxw			;define screen character
Data_logo	LDX	#$0000				;w
		JSL	~Data1_7
		DB	2,2
		DB	$00,$00,$00,$00,$00,$00,$00,$00
		DB	$FF,$81,$81,$81,$81,$81,$81,$FF
		DB	1+45+77+3,1
		DB	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		LIB	BITMAP\NEC.BMD
		LIB	BITMAP\NINTENDO.BMD
		DB	$00,$00,$00,$00,$00,$00,$00,$00
		DB	$00,$00,$00,$00,$00,$00,$00,$00
		DB	$00,$00,$00,$00,$00,$00,$00,$00
		DB	44,1
		LIB	BITMAP\DSP1.BMD
		LIB	BITMAP\UPD77C25.BMD
		DB	0
;
		mbxw			;define sprite character
Data_ball	LDX	#$4000				;w
		JSL	~Data1_4
		DB	16*4
		LIB	BITMAP\BALL.BMD
;
		mbxw				;define screen
Screen_ground	LDA	#step_L				;b
		STA	!Screen_step			;b
		LDX	#$0000				;w
		STX	!Screen_address			;w
		LDA	#$01				;b
_loop0		STA	!Screen_write+0			;b
		INX
		CPX	#16384				;w
		BNE	_loop0
		LDX	#6
		LDY	#$1D32				;w
_loop2		STY	!Screen_address			;w
		LDA	#29				;b
_loop1		STZ	!Screen_write			;b
		DEC	A
		BNE	_loop1
		mW	fC
		TYA
		ADC	#$0080				;w
		TAY
		mB
		DEX
		BNE	_loop2
		LDX	#4
		LDY	#$2138				;w
_loop4		STY	!Screen_address			;w
		LDA	#16				;b
_loop3		STZ	!Screen_write			;b
		DEC	A
		BNE	_loop3
		mW	fC
		TYA
		ADC	#$0080				;w
		TAY
		mB
		DEX
		BNE	_loop4
		RTL
;
PAGE0		GROUP
logo_pointer	DS	2
;
DATA		GROUP
logo_execute	DS	5
;
BANK3		GROUP
logo_bank	EQU	$03
		RADIX	16
data_NEC	DB	00,00,00,00,00,00,03,04,00,05,06,07
		DB	08,09,0A,$0B,0C,$0D,00,00,00,00,00,00,00
		DB	00,00,00,00,00,00,0E,0F,10,11,12,13
		DB	14,15,16,17,00,18,00,00,00,00,00,00,00
		DB	00,00,00,00,00,00,19,1A,$1B,1C,$1D,1E
		DB	1F,20,21,22,23,24,00,00,00,00,00,00,00
		DB	00,00,00,00,00,00,25,00,26,27,28,29
		DB	2A,$2B,2C,$2D,2E,2F,00,00,00,00,00,00,00
		DB	90,91,92,93,94,95,96,97,98,99,9A,$9B,9C,$9D,9E
		DB	9F,$A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD
data_Nintendo	DB	02,30,31,32,33,34,00,00,00,35,36,00
		DB	00,00,00,00,00,00,00,00,37,38,00,00,00
		DB	02,39,3A,$3B,3C,$3D,3E,3F,40,41,42,43
		DB	44,45,46,47,48,49,4A,$4B,4C,$4D,4E,4F,50
		DB	02,51,52,53,54,55,56,00,57,58,59,5A
		DB	$5B,5C,$5D,5E,00,5F,60,61,62,63,64,65,66
		DB	67,00,68,69,6A,$6B,6C,00,$6D,6E,6F,70
		DB	71,72,73,74,00,75,76,77,78,79,7A,$7B,7C
		DB	00,00,00,80,81,82,83,84,85,86,87,00,00,00
		DB	00,00,00,88,89,8A,$8B,8C,$8D,8E,8F,00,00,00
		RADIX	10
;
		mbxw				;define log screen
Screen_logo	LDX	#data_Nintendo			;w
		BCC	_skip
		LDX	#data_NEC			;w
_skip		STX	.logo_pointer			;w
		LDX	#logo_execute			;w
		JSL	~Reserve_NMI
		LDA	#step_L+step_1			;b
		STA	!Screen_step			;b
		LDA	#dma_ST+dma_INC+dma_1B		;b
		STA	!DMA_0+DMA_control		;b
		LDA	#Screen_write+0&$FF		;b
		STA	!DMA_0+DMA_register		;b
		LDX	.logo_pointer			;w
		LDA	#logo_bank			;b
		STX	!DMA_0+DMA_address+0		;w
		STA	!DMA_0+DMA_address+2		;b
		LDA	#dma_0				;b
		LDX	#25				;w
		LDY	#$1DB4				;w
		STY	!Screen_address			;w
		STX	!DMA_0+DMA_count		;w
		STA	!DMA_burst			;b
		LDY	#$1E34				;w
		STY	!Screen_address			;w
		STX	!DMA_0+DMA_count		;w
		STA	!DMA_burst			;b
		LDY	#$1EB4				;w
		STY	!Screen_address			;w
		STX	!DMA_0+DMA_count		;w
		STA	!DMA_burst			;b
		LDY	#$1F34				;w
		STY	!Screen_address			;w
		STX	!DMA_0+DMA_count		;w
		STA	!DMA_burst			;b
		LDX	#14				;w
		LDY	#$21B9				;w
		STY	!Screen_address			;w
		STX	!DMA_0+DMA_count		;w
		STA	!DMA_burst			;b
		LDY	#$2239				;w
		STY	!Screen_address			;w
		STX	!DMA_0+DMA_count		;w
		STA	!DMA_burst			;b
		RTL
;
		END
